//+------------------------------------------------------------------+
//|                                               NonLagZigZagEA.mq4 |
//|                                       Copyright  2006, Aaragorn |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Aaragorn"
#property link      "http://www.forex-tsd.com/member.php?u=8267"
//
/* System specific */
//
string SystemName = "NonLagZigZagEA";
double version = 1;
//---- input parameters
extern bool       Usefilewrite = false;//saves data to file
extern bool          UseAlerts = True;//allows alerts to be displayed
extern bool      Usetimefilter = false;
extern double    InitialLots=0.1;
extern int       MaxOpenTrade=8;
extern double HH_LLAvePeriod = 8;
extern int     EntryVariance = 3;
extern double TakeProfit = 150;
extern double StopLoss = 35;
//------------------INCLUDES---------------//
#include <stdlib.mqh>
//------------------GLOBALS---------------//
double zz=0,MA=0,trend=0,del=0,avdel=0,zz1=0,MA1=0,trend1=0,del1=0,avdel1=0;
double HH=0,LL=0,Spread=0,Slippage=0,Lots=0,basket=0,lastzz=0;
int cnt=0,total=0,ticket=0,SL=500,TP=1000;
bool BlockExitBuy = false;
bool BlockExitSell = false;
bool    BlockSell = false;
bool    BlockBuy  = false;
bool StepAllowed = true;
////////////////////////Aaragorn's One order per bar function
bool OOPBBlockSell = false;
bool OOPBBlockBuy = false;


extern int    GMT=0;                         // For North Finance GMT = 3, Alpari GMT = 1, IBFX GMT = -1 etc.
extern int MagicNumber=784512;               // Magic Number -- change for every pair traded

// ----


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

      //HH = High[Highest(NULL,0,MODE_HIGH,HH_LLAvePeriod,0)];    
      //LL = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriod,0)];
      
      //--present bar
      zz = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,0,0);
      MA = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,1,0);
      trend = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,2,0);
      del = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,3,0);
      avdel = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,4,0);
     
      //--nearest completed bar
      zz1 = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,0,1);
      MA1 = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,1,1);
      trend1 = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,2,1);
      del1 = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,3,1);
      avdel1 = iCustom(NULL,0,"NonLagZigZag_v1",0,14,8,2,4,1);
            
      Print(" zz: ",zz," MA: ",MA," trend: ",trend," del: ",del," avdel: ",avdel," OrdersTotal: ",OrdersTotal()); 
      Print(" zz1: ",zz1," MA1: ",MA1," trend1: ",trend1," del1: ",del1," avdel1: ",avdel1," OrdersTotal: ",OrdersTotal()); 
      
      TP = TakeProfit;
      SL = StopLoss;
      if( trend>0 && zz>0 )
         { 
         ExitBuy();
         TimeCheck();
         OpenSell();
         }
      if( trend<0 && zz>0 )
         {
         ExitSell();
         TimeCheck();
         OpenBuy();
         }
      
      basket();
      


//----
   return(0);
}//start
//+---------------------Trade Hours Function-----------------------------------------+

int TimeCheck() 
{
    if(Usetimefilter == true)
      {
      int hadj=TimeHour(CurTime())-GMT;
    
      if ( (hadj) < 02 || (hadj) >= 10 ) 
        {
        BlockSell = true;
        BlockBuy  = true; 
        } 
        else 
        {
        BlockSell = false;
        BlockBuy  = false;
        }//else 
      } 
      return(0);
}//TimeCheck

//+---------------------Basket Function-----------------------------------------+
void basket()
{
   basket = AccountEquity() - AccountBalance();
   if(OrdersTotal()>=3 && basket > 13) {EXIT();}
   if(OrdersTotal()>=3 && basket < -8.5) {EXIT();}
return(0);
}
//+---------------------Pip Stepper---------------------------------------------+
void PipStepper()
{
   StepAllowed = true;//1st order
   if(OrdersTotal()==0)
      {
      Print("PStep 1st Order StepAllowed: ",StepAllowed);
      }
   //we generate the eurusd-modified parabolic factor
   if(OrdersTotal() > 0)
      {  
      StepAllowed = false;
      Print("PipStep is ACTIVE StepAllowed: ",StepAllowed);
      for(int cnt = 0; cnt < OrdersTotal(); cnt++)
         { 
         cnt = OrdersTotal()-1; 
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)// if this code has an open order on this currency
            {
             if(OrderType()==OP_BUY)  // If the obtained order is by the acquisition of the currency
               {
                if(OrdersTotal()==1)
                  {
                  if(Ask + (10*Point) <= OrderOpenPrice()) {StepAllowed = true;}
                  Print("BPstep2 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//2nd order
               if(OrdersTotal()==2)
                  {
                  if(Ask + (15*Point) <= OrderOpenPrice()) {StepAllowed = true;}
                  Print("BPstep3 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//3rd order  
               if(OrdersTotal()==3)
                  {
                  if(Ask + (50*Point) <= OrderOpenPrice()) {StepAllowed = true;}
                  Print("BPstep4 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//4th order
               if(OrdersTotal()==4)
                  {
                  if(Ask + (50*Point) <= OrderOpenPrice()) {StepAllowed = true;}
                  Print("BPstep5 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//5th order   
               if(OrdersTotal()==5)
                  {
                  if(Ask + (50*Point) <= OrderOpenPrice()) {StepAllowed = true;}
                  Print("BPstep6 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//6th order  
               if(OrdersTotal()==6)
                  {
                  if(Ask + (50*Point) <= OrderOpenPrice()) {StepAllowed = true;}
                  Print("BPstep7 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//7th order
               if(OrdersTotal()==7)
                  {
                  if(Ask + (50*Point) <= OrderOpenPrice()) {StepAllowed = true;}
                  Print("BPstep8 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//8th order 
               return(0);                                 
               }//if buy

             if(OrderType()==OP_SELL)  // If the obtained order is by the selling of the currency
               {
                if(OrdersTotal()==1)
                  {
                  if(Bid - (10*Point) >= OrderOpenPrice()) {StepAllowed = true;}
                  Print("SPstep2 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//2nd order
               if(OrdersTotal()==2)
                  {
                  if(Bid - (15*Point) >= OrderOpenPrice()) {StepAllowed = true;}
                  Print("SPstep3 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//3rd order  
               if(OrdersTotal()==3)
                  {
                  if(Bid - (20*Point) >= OrderOpenPrice()) {StepAllowed = true;}
                  Print("SPstep4 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//4th order
               if(OrdersTotal()==4)
                  {
                  if(Bid - (25*Point) >= OrderOpenPrice()) {StepAllowed = true;}
                  Print("SPstep5 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//5th order   
               if(OrdersTotal()==5)
                  {
                  if(Bid - (60*Point) >= OrderOpenPrice()) {StepAllowed = true;}
                  Print("SPstep6 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//6th order  
               if(OrdersTotal()==6)
                  {
                  if(Bid - (65*Point) >= OrderOpenPrice()) {StepAllowed = true;}
                  Print("SPstep7 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//7th order
               if(OrdersTotal()==7)
                  {
                  if(Bid - (80*Point) >= OrderOpenPrice()) {StepAllowed = true;}
                  Print("SPstep8 found ticket: ",OrderTicket()," StepAllowed: ",StepAllowed);
                  }//8th order 
               return(0);                                    
               }//if sell                  
            }//symbol & magic  
         }//for    
      }//orderstotal>0
   return(0);
}//pipstepper
//+---------------------Series Lots---------------------------------------------+
void SeriesLots()
{
              // Print("Initial Lots: ",InitialLots);
              // Print("Before Lots: ",Lots);
                  
               //----Series Lots
               //we generate the eurusd-modified parabolic factor
               double factor =0.01;//1st order
               if(OrdersTotal() > 0)
                  {
                  if(OrdersTotal()==1) {factor = 0.02;}//2nd order
                  if(OrdersTotal()==2) {factor = 0.04;}//3rd order
                  if(OrdersTotal()==3) {factor = 0.08;}//4th order
                  if(OrdersTotal()==4) {factor = 0.16;}//5th order
                  if(OrdersTotal()==5) {factor = 0.32;}//6th order
                  if(OrdersTotal()==6) {factor = 0.64;}//7th order
                  if(OrdersTotal()==7) {factor = 1.28;}//8th order
                  
                  //Print("factor: ",factor);
                                    
                  Lots = InitialLots;//0.01
                  //Print("Initial Series Lots: ",Lots);//0.01//0.02
                   
                  Lots = NormalizeDouble((OrdersTotal()+1) * factor,2);//2*0.02//3*0.04//4*0.08
                  //Print("Before Max Series Lots: ",Lots);
                  if(Lots > 10)
                     {
                     Lots = 10;
                     }
                 // Print("Final Series Lots: ",Lots);       
                  }
                  else
                  {
                  Lots = InitialLots;//passage for first order @0.01
                  }
                 //Print("Final Lots: ",Lots);
return(0);
}

//+---------------------OPENS---------------------------------------------+

int OpenBuy()
{
   HH = High[Highest(NULL,0,MODE_HIGH,HH_LLAvePeriod,0)];    
   LL = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriod,0)];
   Spread = Ask - Bid;
   int handle=0;
   // We limit the number of open orders allowed to enter into the market
   if( (OrdersTotal() < MaxOpenTrade) && (Ask - Spread - (EntryVariance*Point) <= zz) && (Ask - Spread - (EntryVariance*Point) <= LL) )
      {

                OneOrderPerSignal();
                if(BlockBuy == true)//Aaragorns good hours filter
                  {
                    return(0);
                  }
                if(OOPBBlockBuy == true)//Aaragorns one order per bar filter
                  {
                    return(0);
                  }
                PipStepper(); 
                if(StepAllowed == false)//Aaragorns pipstepper filter
                  {
                    return(0);
                  } 
                SeriesLots();
                //Lots = InitialLots;//passage for first order @0.01
                //---- Open Long Order  
                ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, Ask - (SL*Point), Ask + (TP * Point), "Order Opened Long", MagicNumber, 0, Blue);
                   if(ticket > 0)
                     {
                       
                     if (Usefilewrite)
                          {
                           datetime borderOpen=OrderOpenTime();
                           handle = FileOpen("nonlagzigzagEA.txt",FILE_READ|FILE_WRITE);
                           if(handle!=-1)
                             {
                             FileSeek(handle,0,SEEK_END);
                             FileWrite(handle,"Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Order Open Time: ",borderOpen," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity()," lastzz: ",lastzz," LL: ",LL);
                             FileWrite(handle," zz: ",zz," MA: ",MA," trend: ",trend," del: ",del," avdel: ",avdel," OrdersTotal: ",OrdersTotal()); 
                             FileWrite(handle," zz1: ",zz1," MA1: ",MA1," trend1: ",trend1," del1: ",del1," avdel1: ",avdel1," OrdersTotal: ",OrdersTotal()); 
      
                             FileWrite(handle,"  ");
                    
                             FileFlush(handle);
	                          FileClose(handle);
	                          }  
	                        }  
                       Lots = InitialLots;
                       lastzz=zz;
                       if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                       {
                        if(UseAlerts == True)
                           {
                           PlaySound("alert.wav");
                           Alert("Buying Alert --- Buying ",Lots,Symbol(), " @ ",Ask);
                           }
                        }
                     }                             
                     else
                     {
                       Print("Error on the Short Entry: ",GetLastError());
                       PrintErrorValues();
                     }
                   return (0);
               
      }
}  
  
//+---------------------OPENS---------------------------------------------+

int OpenSell()
{
   HH = High[Highest(NULL,0,MODE_HIGH,HH_LLAvePeriod,0)];    
   LL = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriod,0)];
   Spread = Ask - Bid;
   int handle=0;
   // We limit the number of open orders allowed to enter into the market
   if( (OrdersTotal() < MaxOpenTrade) && (Bid + Spread + (EntryVariance*Point) >= zz) && (Bid + Spread + (EntryVariance*Point) >= HH) )
      {
               OneOrderPerSignal();
               if(BlockSell == true)//Aaragorns good hours filter
                  {
                    return(0);
                  }
                if(OOPBBlockSell == true)//Aaragorns one order per bar filter
                  {
                    return(0);
                  }
                PipStepper(); 
                if(StepAllowed == false)//Aaragorns pipstepper filter
                  {
                    return(0);
                  }                  
                SeriesLots();
                //Lots = InitialLots;//passage for first order @0.01    
               //---- Open Short Order
                ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, Bid + (SL*Point), Bid - (TP * Point), "Order Opened Short", MagicNumber, 0, Red);
                   if(ticket > 0)
                     {
                         if (Usefilewrite)
                          {
                           datetime borderOpen=OrderOpenTime();
                           handle = FileOpen("nonlagzigzagEA.txt",FILE_READ|FILE_WRITE);
                           if(handle!=-1)
                             {
                             FileSeek(handle,0,SEEK_END);
                             FileWrite(handle,"Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Order Open Time: ",borderOpen," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity()," lastzz: ",lastzz," HH: ",HH);
                             FileWrite(handle," zz: ",zz," MA: ",MA," trend: ",trend," del: ",del," avdel: ",avdel," OrdersTotal: ",OrdersTotal()); 
                             FileWrite(handle," zz1: ",zz1," MA1: ",MA1," trend1: ",trend1," del1: ",del1," avdel1: ",avdel1," OrdersTotal: ",OrdersTotal()); 
      
                             FileFlush(handle);
	                          FileClose(handle);
	                          }  
	                        }
                       Lots = InitialLots;
                       lastzz=zz;
                       if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                       {
                        if(UseAlerts == True)
                           {
                           PlaySound("alert.wav");
                           Alert("Selling Alert --- Selling ",Lots,Symbol(), "@" ,Bid);
                           }
                        }
                     }                             
                     else
                     {
                       Print("Error on the Short Entry: ",GetLastError());
                       PrintErrorValues();
                     }
                   return (0);
                     
       }
}

/////////////////////One order per signal by Aaragorn///////////////
void OneOrderPerSignal ()
{
      OOPBBlockBuy = false;
      OOPBBlockSell = false;
      if(OrdersTotal() > 0)
      {
      for(int cnt1 = 0; cnt1 < OrdersTotal(); cnt1++)
         {
         OrderSelect(cnt1, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)// if this EA has an open order on this currency
            {
            if( lastzz == zz )
               {
               OOPBBlockBuy = true;
               OOPBBlockSell = true;
               }        
            else
               {
               OOPBBlockBuy = false;
               OOPBBlockSell = false;
               }
             }//if symbol     
          }//for
       }//if     
   return(0); 
}
///////////////////end of One order per bar by Aaragorn///////////////////

//+-------------------------EXITS-------------------------------------------------------------------------------------------------------------------------------------------------+

int ExitBuy()
{   
   for(int cnt = 0; cnt < OrdersTotal(); cnt++)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         // We search for orders opened by this code on our currency
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)// if this code has an open order on this currency
            {
            Print("EB found ticket: ",OrderTicket()," type: ",OrderType()," total open orders: ",OrdersTotal());
             if(OrderType()==OP_BUY)  // If the obtained order is by the acquisition of the currency
               {
               //OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Blue);
                BlockExitSell = true;
                BlockExitBuy = false;
                EXIT();
               }
             return(0);   
            }//symbol & magic
     }//for     
}//exit buy

//+-------------------------EXITS-------------------------------------------------------------------------------------------------------------------------------------------------+

int ExitSell()
{
   for(int cnt = 0; cnt < OrdersTotal(); cnt++)
      {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         // We search for orders opened by this code on our currency
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)// if this code has an open order on this currency
            {
            Print("ES found ticket: ",OrderTicket()," type: ",OrderType()," total open orders: ",OrdersTotal());
             if(OrderType()==OP_SELL)  // If the obtained order is by the selling of the currency
               {
                //OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Red);
                BlockExitBuy = true;
                BlockExitSell = false;
                EXIT();
               }
             return(0);   
            }//symbol & magic
     }//for     
}//exit sell

//+-------------------------EXITS-------------------------------------------------------------------------------------------------------------------------------------------------+

////closes all orders//////////
void EXIT()
{
   Spread = Ask - Bid;
   int handle=0;

   for( cnt = OrdersTotal()-1; cnt >= 0; cnt-- ) 
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES); 
      if( OrderSymbol() ==  Symbol() && OrderMagicNumber() == MagicNumber ) 
         {
            if( OrderType() ==  OP_BUY && BlockExitBuy == false)  
               {
               OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Blue);
                  if (Usefilewrite)
                  {  
                     if(OrderOpenPrice() + Spread < OrderClosePrice())
                     {   
                        datetime borderOpen=OrderOpenTime();
                        handle = FileOpen("nonlagzigzagEA.txt",FILE_READ|FILE_WRITE);
                        if(handle!=-1)
                          {
                          FileSeek(handle,0,SEEK_END);
                          FileWrite(handle,"Winning Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",borderOpen," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                          //FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                          FileWrite(handle,"  ");
                    
                          FileFlush(handle);
	                       FileClose(handle);
	                       Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
	                       }   
                          else
                          {
                          int err;
                          err=GetLastError();
                          Print("error(",err,"): ",ErrorDescription(err));
                          //return(0);                     
                          } 
                    }//if win
                    Print("Recorded Winning Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);     

                     if(OrderOpenPrice() + Spread >= OrderClosePrice())
                     {
                        datetime blorderOpen=OrderOpenTime();
                        handle = FileOpen("nonlagzigzagEA.txt",FILE_READ|FILE_WRITE);
                        if(handle!=-1)
                          {
                          FileSeek(handle,0,SEEK_END);
                          FileWrite(handle,"Losing Long OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",borderOpen," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                          //FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                          FileWrite(handle,"  ");
                          FileFlush(handle);
	                       FileClose(handle);
	                       Print("Recorded Losing Long ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Bid);
                   
	                       }   
                          else
                          {
                          int err1;
                          err1=GetLastError();
                          Print("error(",err1,"): ",ErrorDescription(err1));
                          return(0);                     
                          } 
                      }//if lose  
                  }//if use file write  
               }//if type buy
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES); 
            if( OrderSymbol() ==  Symbol() && OrderMagicNumber() == MagicNumber )
            {   
            if( OrderType() ==  OP_SELL && BlockExitSell == false)
               {
               OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Red);
               if (Usefilewrite)
               {  
                 if(OrderOpenPrice() - Spread > OrderClosePrice()) 
                  {
                     datetime sorderOpen=OrderOpenTime();
                     handle = FileOpen("nonlagzigzagEA.txt",FILE_READ|FILE_WRITE);
                     if(handle!=-1)
                       {
                       FileSeek(handle,0,SEEK_END);
                       FileWrite(handle,"Winning Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",sorderOpen," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                       //FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                       FileWrite(handle,"  ");
                       FileFlush(handle);
	                    FileClose(handle);
                       Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
                       }   
                       else
                       {
                       int err3;
                       err3=GetLastError();
                       Print("error(",err3,"): ",ErrorDescription(err3));
                       //return(0);                     
                       }  
                  }//if win 
                  //Print("Recorded Winning Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask); 
              
                  if(OrderOpenPrice() - Spread <= OrderClosePrice())
                     {  
                     datetime slorderOpen=OrderOpenTime();
                     handle = FileOpen("nonlagzigzagEA.txt",FILE_READ|FILE_WRITE);
                     if(handle!=-1)
                       {
                       FileSeek(handle,0,SEEK_END);
                       FileWrite(handle,"Losing Short OrderTicket: ",OrderTicket(),"  Opened @: ",OrderOpenPrice(),"  Closed @: ",OrderClosePrice(),"  Order Open Time: ",slorderOpen," AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                       //FileWrite(handle,"AccountBalance: ",AccountBalance()," AccountEquity: ",AccountEquity());
                       FileWrite(handle,"  ");
                       FileFlush(handle);
	                    FileClose(handle);
                       Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);
                       }   
                       else
                       {
                       int err4;
                       err4=GetLastError();
                       Print("error(",err4,"): ",ErrorDescription(err4));
                       return(0);                     
                       }  
                     }//if lose 
                     //Print("Recorded Losing Short ",OrderTicket()," Opened: ",OrderOpenPrice(),"  Closed: ", Ask);   
               }//if use file write
            }//if type sell
            }//if EA order for sell
      }//if EA order for buy
   }//for counter
   BlockExitBuy = false;
   BlockExitSell = false;
return(0);
}
//////////end of EXIT all orders/////////////////
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
int PrintErrorValues()
  {
   Print("ErrorValues:Symbol=", Symbol(),",Lots=",Lots, ",Bid=", Bid, ",Ask=", Ask,
         ",SlipPage=", Slippage, "StopLoss=",SL,",TakeProfit=", TP, "tp * point= ",(TP*Point));
   return (0);
  }
//+--------------------------------------------------------------------------------------------------------------------------------------------------------------------------+

